﻿using System;
using System.Linq;

using Microsoft.EntityFrameworkCore;

namespace Platform.Sql.ChangeMonitor
{
    public interface IQueryChangeMonitor : IDisposable
    {
        string Name { get; set; }

        event EventHandler Changed;

        void Start<TEntity>(DbContext context, IQueryable<TEntity> query)
            where TEntity : class;

        void Start(DbContext context, string sql);

        void Start(string connection, string sql);

        void Stop();
    }
}
